Index: branches/TAM_V3_0/NEMOTAM/OPATAM_SRC/DYN/dynvor_tam.F90
===================================================================
--- branches/TAM_V3_0/NEMOTAM/OPATAM_SRC/DYN/dynvor_tam.F90	(revision 1947)
+++ branches/TAM_V3_0/NEMOTAM/OPATAM_SRC/DYN/dynvor_tam.F90	(revision 2587)
@@ -581,4 +893,242 @@
    END SUBROUTINE vor_ens_adj
 
+
+   SUBROUTINE vor_een_adj( kt, kvor, pua_ad, pva_ad )
+      !!----------------------------------------------------------------------
+      !!                ***  ROUTINE vor_een_adj  ***
+      !!
+      !! ** Purpose :   Compute the now total vorticity trend and add it to 
+      !!      the general trend of the momentum equation.
+      !!
+      !! ** Method  :   Trend evaluated using now fields (centered in time) 
+      !!      and the Arakawa and Lamb (19XX) flux form formulation : conserves 
+      !!      both the horizontal kinetic energy and the potential enstrophy
+      !!      when horizontal divergence is zero.
+      !!      The trend of the vorticity term is given by:
+      !!       * s-coordinate (ln_sco=T), the e3. are inside the derivatives:
+      !!       * z-coordinate (default key), e3t=e3u=e3v, the trend becomes:
+      !!      Add this trend to the general momentum trend (ua,va):
+      !!          (ua,va) = (ua,va) + ( voru , vorv )
+      !!
+      !! ** Action : - Update (ua,va) with the now vorticity term trend
+      !!             - save the trends in (ztrdu,ztrdv) in 2 parts (relative
+      !!               and planetary vorticity trends) ('key_trddyn')
+      !!
+      !! References : Arakawa and Lamb 1980, Mon. Wea. Rev., 109, 18-36
+      !!----------------------------------------------------------------------
+      INTEGER , INTENT(in   )                         ::   kt     ! ocean time-step index
+      INTEGER , INTENT(in   )                         ::   kvor   ! =ncor (planetary) ; =ntot (total) ;
+         !                                                        ! =nrvm (relative vorticity or metric)
+      REAL(wp), INTENT(inout), DIMENSION(jpi,jpj,jpk) ::   pua_ad ! total u-trend
+      REAL(wp), INTENT(inout), DIMENSION(jpi,jpj,jpk) ::   pva_ad ! total v-trend
+      !!
+      INTEGER ::   ji, jj, jk          ! dummy loop indices
+      REAL(wp) ::   zfac12             ! temporary scalars
+      REAL(wp) ::   zuaad, zvaad       ! temporary scalars
+      REAL(wp), DIMENSION(jpi,jpj) ::   zwx, zwy, zwz                    ! temporary 2D workspace
+      REAL(wp), DIMENSION(jpi,jpj) ::   ztnw, ztne, ztsw, ztse           ! temporary 3D workspace
+      REAL(wp), DIMENSION(jpi,jpj) ::   zwxad, zwyad, zwzad              ! temporary 2D workspace
+      REAL(wp), DIMENSION(jpi,jpj) ::   ztnwad, ztnead, ztswad, ztsead   ! temporary 3D workspace
+      REAL(wp), DIMENSION(jpi,jpj,jpk), SAVE ::   ze3f
+      !!----------------------------------------------------------------------
+
+      ! local adjoint initailization
+      zuaad = 0.0_wp ; zvaad = 0.0_wp
+      zwxad (:,:) = 0.0_wp ; zwyad (:,:) = 0.0_wp ; zwzad (:,:) = 0.0_wp
+      ztnwad(:,:) = 0.0_wp ; ztnead(:,:) = 0.0_wp ; ztswad(:,:) = 0.0_wp ; ztsead(:,:) = 0.0_wp
+
+      IF( kt == nitend ) THEN
+         IF(lwp) WRITE(numout,*)
+         IF(lwp) WRITE(numout,*) 'dyn:vor_een_adj : vorticity term: energy and enstrophy conserving scheme'
+         IF(lwp) WRITE(numout,*) '~~~~~~~~~~~'
+
+         DO jk = 1, jpk
+            DO jj = 1, jpjm1
+               DO ji = 1, jpim1
+                  ze3f(ji,jj,jk) = ( fse3t(ji,jj+1,jk)*tmask(ji,jj+1,jk) + fse3t(ji+1,jj+1,jk)*tmask(ji+1,jj+1,jk)   &
+                     &             + fse3t(ji,jj  ,jk)*tmask(ji,jj  ,jk) + fse3t(ji+1,jj  ,jk)*tmask(ji+1,jj  ,jk) ) * 0.25_wp
+                  IF( ze3f(ji,jj,jk) /= 0.0_wp )   ze3f(ji,jj,jk) = 1.0_wp / ze3f(ji,jj,jk)
+               END DO
+            END DO
+         END DO
+         CALL lbc_lnk( ze3f, 'F', 1._wp )
+      ENDIF
+
+      ! Local constant initialization
+      zfac12 = 1.0_wp / 12.0_wp
+   
+!CDIR PARALLEL DO PRIVATE( zwx, zwy, zwz, ztnw, ztne, ztsw, ztse )
+      !                                                ! ===============
+      DO jk = 1, jpkm1                                 ! Horizontal slab
+         !                                             ! ===============
+
+         ! Potential vorticity and horizontal fluxes  (Direct local variables init)
+         ! -----------------------------------------
+         SELECT CASE( kvor )      ! vorticity considered
+         CASE ( 1 )   ;   zwz(:,:) =  ff(:,:) * ze3f(:,:,jk)      ! planetary vorticity (Coriolis)
+         CASE ( 2 )   ;   zwz(:,:) =   rotn(:,:,jk) * ze3f(:,:,jk)                ! relative  vorticity
+         CASE ( 3 )                                                ! metric term
+            DO jj = 1, jpjm1
+               DO ji = 1, fs_jpim1   ! vector opt.
+                  zwz(ji,jj) = ( ( vn(ji+1,jj  ,jk) + vn (ji,jj,jk) ) * ( e2v(ji+1,jj  ) - e2v(ji,jj) )  &
+                       &       - ( un(ji  ,jj+1,jk) + un (ji,jj,jk) ) * ( e1u(ji  ,jj+1) - e1u(ji,jj) ) )&
+                       &     * 0.5 / ( e1f(ji,jj) * e2f(ji,jj) ) * ze3f(ji,jj,jk)
+               END DO
+            END DO
+         CASE ( 4 )   ;   zwz(:,:) = ( rotn(:,:,jk) + ff(:,:) ) * ze3f(:,:,jk)    ! total (relative + planetary vorticity)
+         CASE ( 5 )                                                ! total (coriolis + metric)
+            DO jj = 1, jpjm1
+               DO ji = 1, fs_jpim1   ! vector opt.
+                  zwz(ji,jj) = ( ff (ji,jj)                         &
+                       &       + (   ( vn(ji+1,jj  ,jk) + vn (ji,jj,jk) ) * ( e2v(ji+1,jj  ) - e2v(ji,jj) )       &
+                       &           - ( un(ji  ,jj+1,jk) + un (ji,jj,jk) ) * ( e1u(ji  ,jj+1) - e1u(ji,jj) )   )   &
+                       &       * 0.5 / ( e1f(ji,jj) * e2f(ji,jj) )  &
+                       &       ) * ze3f(ji,jj,jk)
+               END DO
+            END DO
+         END SELECT
+
+         zwx(:,:) = e2u(:,:) * fse3u(:,:,jk) * un(:,:,jk)
+         zwy(:,:) = e1v(:,:) * fse3v(:,:,jk) * vn(:,:,jk)
+
+         ! Compute and add the vorticity term trend
+         ! ----------------------------------------
+         jj=2
+         ztne(1,:)   = 0.0_wp ; ztnw(1,:)   = 0.0_wp ; ztse(1,:)   = 0.0_wp ; ztsw(1,:)   = 0.0_wp
+         DO ji = 2, jpi   
+               ztne(ji,jj) = zwz(ji-1,jj  ) + zwz(ji  ,jj  ) + zwz(ji  ,jj-1)
+               ztnw(ji,jj) = zwz(ji-1,jj-1) + zwz(ji-1,jj  ) + zwz(ji  ,jj  )
+               ztse(ji,jj) = zwz(ji  ,jj  ) + zwz(ji  ,jj-1) + zwz(ji-1,jj-1)
+               ztsw(ji,jj) = zwz(ji  ,jj-1) + zwz(ji-1,jj-1) + zwz(ji-1,jj  )
+         END DO
+         DO jj = 3, jpj
+            DO ji = fs_2, jpi   ! vector opt.
+               ztne(ji,jj) = zwz(ji-1,jj  ) + zwz(ji  ,jj  ) + zwz(ji  ,jj-1)
+               ztnw(ji,jj) = zwz(ji-1,jj-1) + zwz(ji-1,jj  ) + zwz(ji  ,jj  )
+               ztse(ji,jj) = zwz(ji  ,jj  ) + zwz(ji  ,jj-1) + zwz(ji-1,jj-1)
+               ztsw(ji,jj) = zwz(ji  ,jj-1) + zwz(ji-1,jj-1) + zwz(ji-1,jj  )
+            END DO
+         END DO
+
+      ! ===================
+      ! Adjoint counterpart
+      ! ===================
+
+         DO jj = jpjm1, 2, -1
+            DO ji = fs_jpim1, fs_2, -1   ! vector opt.
+               zuaad = zuaad + pua_ad(ji,jj,jk)
+               zvaad = zvaad + pva_ad(ji,jj,jk)
+
+               zvaad = - zvaad * zfac12 / e2v(ji,jj)
+               ztswad(ji  ,jj+1) = ztswad(ji  ,jj+1) + zvaad * zwx (ji-1,jj+1)
+               zwxad (ji-1,jj+1) = zwxad (ji-1,jj+1) + zvaad * ztsw(ji  ,jj+1)
+               ztsead(ji  ,jj+1) = ztsead(ji  ,jj+1) + zvaad * zwx (ji  ,jj+1)
+               zwxad (ji  ,jj+1) = zwxad (ji  ,jj+1) + zvaad * ztse(ji  ,jj+1)
+               ztnwad(ji  ,jj  ) = ztnwad(ji  ,jj  ) + zvaad * zwx (ji-1,jj  )
+               zwxad (ji-1,jj  ) = zwxad (ji-1,jj  ) + zvaad * ztnw(ji  ,jj  )
+               ztnead(ji  ,jj  ) = ztnead(ji  ,jj  ) + zvaad * zwx (ji  ,jj  )
+               zwxad (ji  ,jj  ) = zwxad (ji  ,jj  ) + zvaad * ztne(ji  ,jj  )
+               zvaad = 0.0_wp
+
+               zuaad = zuaad * zfac12 / e1u(ji,jj)
+               ztnead(ji  ,jj  ) = ztnead(ji  ,jj  ) + zuaad * zwy (ji  ,jj  )
+               zwyad (ji  ,jj  ) = zwyad (ji  ,jj  ) + zuaad * ztne(ji  ,jj  )
+               ztnwad(ji+1,jj  ) = ztnwad(ji+1,jj  ) + zuaad * zwy (ji+1,jj  )
+               zwyad (ji+1,jj  ) = zwyad (ji+1,jj  ) + zuaad * ztnw(ji+1,jj  )
+               ztsead(ji  ,jj  ) = ztsead(ji  ,jj  ) + zuaad * zwy (ji  ,jj-1)
+               zwyad (ji  ,jj-1) = zwyad (ji  ,jj-1) + zuaad * ztse(ji  ,jj  )
+               ztswad(ji+1,jj  ) = ztswad(ji+1,jj  ) + zuaad * zwy (ji+1,jj-1)
+               zwyad (ji+1,jj-1) = zwyad (ji+1,jj-1) + zuaad * ztsw(ji+1,jj  )
+               zuaad = 0.0_wp
+            END DO  
+         END DO 
+         DO jj = jpj, 3, -1
+            DO ji = jpi, fs_2, -1   ! vector opt.
+               zwzad (ji  ,jj-1) = zwzad(ji  ,jj-1) + ztswad(ji,jj) 
+               zwzad (ji-1,jj-1) = zwzad(ji-1,jj-1) + ztswad(ji,jj)
+               zwzad (ji-1,jj  ) = zwzad(ji-1,jj  ) + ztswad(ji,jj)
+               ztswad(ji  ,jj  ) = 0.0_wp
+               zwzad (ji  ,jj  ) = zwzad(ji  ,jj  ) + ztsead(ji,jj)
+               zwzad (ji  ,jj-1) = zwzad(ji  ,jj-1) + ztsead(ji,jj)
+               zwzad (ji-1,jj-1) = zwzad(ji-1,jj-1) + ztsead(ji,jj)
+               ztsead(ji,jj)     = 0.0_wp
+               zwzad (ji-1,jj-1) = zwzad(ji-1,jj-1) + ztnwad(ji,jj)
+               zwzad (ji-1,jj  ) = zwzad(ji-1,jj  ) + ztnwad(ji,jj)
+               zwzad (ji  ,jj  ) = zwzad(ji  ,jj  ) + ztnwad(ji,jj)
+               ztnwad(ji  ,jj  ) = 0.0_wp
+               zwzad (ji-1,jj  ) = zwzad(ji-1,jj  ) + ztnead(ji,jj)
+               zwzad (ji  ,jj  ) = zwzad(ji  ,jj  ) + ztnead(ji,jj)
+               zwzad (ji  ,jj-1) = zwzad(ji  ,jj-1) + ztnead(ji,jj)
+               ztnead(ji,jj)     = 0.0_wp
+            END DO
+         END DO
+         jj=2
+         DO ji = jpi, 2, -1   
+               zwzad (ji  ,jj-1) = zwzad(ji  ,jj-1) + ztswad(ji,jj)
+               zwzad (ji-1,jj-1) = zwzad(ji-1,jj-1) + ztswad(ji,jj)
+               zwzad (ji-1,jj  ) = zwzad(ji-1,jj  ) + ztswad(ji,jj)
+               ztswad(ji,jj) = 0.0_wp
+               zwzad (ji  ,jj  ) = zwzad(ji  ,jj  ) + ztsead(ji,jj)
+               zwzad (ji  ,jj-1) = zwzad(ji  ,jj-1) + ztsead(ji,jj)
+               zwzad (ji-1,jj-1) = zwzad(ji-1,jj-1) + ztsead(ji,jj)
+               ztsead(ji  ,jj  ) = 0.0_wp
+               zwzad (ji-1,jj-1) = zwzad(ji-1,jj-1) + ztnwad(ji,jj)
+               zwzad (ji-1,jj  ) = zwzad(ji-1,jj  ) + ztnwad(ji,jj)
+               zwzad (ji  ,jj  ) = zwzad(ji  ,jj  ) + ztnwad(ji,jj)
+               ztnwad(ji  ,jj ) = 0.0_wp
+               zwzad (ji-1,jj  ) = zwzad(ji-1,jj  ) + ztnead(ji,jj)
+               zwzad (ji  ,jj  ) = zwzad(ji  ,jj  ) + ztnead(ji,jj)
+               zwzad (ji  ,jj-1) = zwzad(ji  ,jj-1) + ztnead(ji,jj)
+               ztnead(ji  ,jj  ) = 0.0_wp
+         END DO
+         ztnead(1,:)   = 0.0_wp ; ztnwad(1,:)   = 0.0_wp 
+         ztsead(1,:)   = 0.0_wp ; ztswad(1,:)   = 0.0_wp
+
+         vn_ad(:,:,jk) = vn_ad(:,:,jk) + zwyad(:,:) * e1v(:,:) * fse3v(:,:,jk)
+         un_ad(:,:,jk) = un_ad(:,:,jk) + zwxad(:,:) * e2u(:,:) * fse3u(:,:,jk)
+         zwyad(:,:)    = 0.0_wp
+         zwxad(:,:)    = 0.0_wp
+
+         ! Potential vorticity and horizontal fluxes
+         ! -----------------------------------------
+         SELECT CASE( kvor )      ! vorticity considered
+         CASE ( 1 )   
+            zwzad(:,:) = 0.0_wp
+         CASE ( 2 )   
+            rotn_ad(:,:,jk) = rotn_ad(:,:,jk) +  zwzad(:,:) * ze3f(:,:,jk)
+            zwzad(:,:)      = 0.0_wp
+         CASE ( 3 )                                                ! metric term
+            DO jj = jpjm1, 1, -1
+               DO ji = fs_jpim1, 1, -1   ! vector opt.
+                  zwzad(ji  ,jj     ) = zwzad(ji,jj) * 0.5 / ( e1f(ji,jj) * e2f(ji,jj) ) * ze3f(ji,jj,jk)
+                  vn_ad(ji+1,jj  ,jk) =   vn_ad(ji+1,jj  ,jk) + zwzad(ji,jj) * ( e2v(ji+1,jj  ) - e2v(ji,jj) )
+                  vn_ad(ji  ,jj  ,jk) =   vn_ad(ji  ,jj  ,jk) + zwzad(ji,jj) * ( e2v(ji+1,jj  ) - e2v(ji,jj) )
+                  un_ad(ji  ,jj+1,jk) = - un_ad(ji  ,jj+1,jk) + zwzad(ji,jj) * ( e1u(ji  ,jj+1) - e1u(ji,jj) )
+                  un_ad(ji  ,jj  ,jk) = - un_ad(ji  ,jj  ,jk) + zwzad(ji,jj) * ( e1u(ji  ,jj+1) - e1u(ji,jj) )
+                  zwzad(ji  ,jj     ) = 0.0_wp
+               END DO
+            END DO
+         CASE ( 4 )   
+            rotn_ad(:,:,jk) = rotn_ad(:,:,jk) + zwzad(:,:) * ze3f(:,:,jk)
+            zwzad(:,:) = 0.0_wp
+         CASE ( 5 )                                                ! total (coriolis + metric)
+            DO jj = jpjm1, 1, -1
+               DO ji = fs_jpim1, 1, -1   ! vector opt.
+                  zwzad(ji  ,jj     ) = zwzad(ji,jj) * 0.5 / ( e1f(ji,jj) * e2f(ji,jj) ) * ze3f(ji,jj,jk)
+
+                  vn_ad(ji+1,jj  ,jk) = vn_ad(ji+1,jj  ,jk) + zwzad(ji,jj) * ( e2v(ji+1,jj  ) - e2v(ji,jj) )
+                  vn_tl(ji  ,jj  ,jk) = vn_tl(ji  ,jj  ,jk) + zwzad(ji,jj) * ( e2v(ji+1,jj  ) - e2v(ji,jj) )
+                  un_ad(ji  ,jj+1,jk) = un_ad(ji  ,jj+1,jk) - zwzad(ji,jj) * ( e1u(ji  ,jj+1) - e1u(ji,jj) )
+                  un_ad(ji  ,jj  ,jk) = un_ad(ji  ,jj  ,jk) - zwzad(ji,jj) * ( e1u(ji  ,jj+1) - e1u(ji,jj) )
+
+                  zwzad(ji  ,jj     ) = 0.0_wp
+               END DO
+            END DO
+         END SELECT
+         !                                             ! ===============
+      END DO                                           !   End of slab
+      !                                                ! ===============
+   END SUBROUTINE vor_een_adj
+
    SUBROUTINE vor_ctl_tam
       !!---------------------------------------------------------------------
@@ -599,5 +1149,5 @@
          WRITE(numout,*) 'dyn:vor_ctl_tam : vorticity term : read namelist and control the consistency'
          WRITE(numout,*) '~~~~~~~~~~~~~~~'
-         WRITE(numout,*) '        Namelist nam_dynvor : oice of the vorticity term scheme'
+         WRITE(numout,*) '        Namelist nam_dynvor : choice of the vorticity term scheme'
          WRITE(numout,*) '           energy    conserving scheme                ln_dynvor_ene = ', ln_dynvor_ene
          WRITE(numout,*) '           enstrophy conserving scheme                ln_dynvor_ens = ', ln_dynvor_ens
@@ -679,5 +1229,6 @@
          & ji,    &        ! dummy loop indices
          & jj,    &        
-         & jk     
+         & jk,    &
+         & jt     
       INTEGER, DIMENSION(jpi,jpj) :: &
          & iseed_2d        ! 2D seed for the random number generator
@@ -738,4 +1289,11 @@
          & )
 
+      ! init ntot parameter
+      CALL vor_ctl_tam          ! initialisation & control of options
+
+      DO jt = 1, 2
+         IF (jt == 1) nvor=1 ! enstrophy conserving scheme
+         IF (jt == 2) nvor=3 ! energy and enstrophy conserving scheme
+
       ! Initialize rotn
       CALL div_cur ( nit000 )
@@ -816,8 +1374,5 @@
       END DO
       CALL grid_random( iseed_2d, zav, 'V', 0.0_wp, stdv )
-!zun_tlin(:,:,:) = znu(:,:,:) 
-!zvn_tlin(:,:,:) = znv(:,:,:) 
-!zua_tlin(:,:,:) = zau(:,:,:) 
-!zva_tlin(:,:,:) = zav(:,:,:)
+
       DO jk = 1, jpk
          DO jj = nldj, nlej
@@ -837,5 +1392,5 @@
       ! initialize rotn_tl with noise
       CALL div_cur_tan ( nit000 )
-!zrotn_tlin(:,:,:) = rotn_tl(:,:,:)
+
       DO jk = 1, jpk
         DO jj = nldj, nlej
@@ -847,5 +1402,7 @@
       rotn_tl(:,:,:) = zrotn_tlin(:,:,:)
 
-      CALL dyn_vor_tan( nit000 )
+
+         IF (nvor == 1 )  CALL vor_ens_tan( nit000, ntot, ua_tl, va_tl )
+         IF (nvor == 3 )  CALL vor_een_tan( nit000, ntot, ua_tl, va_tl )
       zua_tlout(:,:,:) = ua_tl(:,:,:)
       zva_tlout(:,:,:) = va_tl(:,:,:)
@@ -882,6 +1439,7 @@
       va_ad(:,:,:) = zva_adin(:,:,:)
 
-      CALL dyn_vor_adj ( nitend )
-
+
+         IF (nvor == 1 )  CALL vor_ens_adj( nitend, ntot, ua_ad, va_ad )
+         IF (nvor == 3 )  CALL vor_een_adj( nitend, ntot, ua_ad, va_ad )
       zun_adout(:,:,:)   = un_ad(:,:,:)
       zvn_adout(:,:,:)   = vn_ad(:,:,:)
@@ -900,6 +1458,9 @@
 
       ! 14 char:'12345678901234'
-      cl_name = 'dyn_vor_adj   '
+         IF (nvor == 1 )  cl_name = 'dynvor_adj ens'
+         IF (nvor == 3 )  cl_name = 'dynvor_adj een'
+
       CALL prntst_adj( cl_name, kumadt, zsp1, zsp2 )
+      END DO
 
       DEALLOCATE( &
Index: branches/TAM_V3_0/NEMOTAM/OPATAM_SRC/DYN/dynzad_tam.F90
===================================================================
--- branches/TAM_V3_0/NEMOTAM/OPATAM_SRC/DYN/dynzad_tam.F90	(revision 1947)
+++ branches/TAM_V3_0/NEMOTAM/OPATAM_SRC/DYN/dynzad_tam.F90	(revision 2587)
@@ -131,8 +131,8 @@
       DO jj = 2, jpjm1              ! Surface and bottom values set to zero
          DO ji = fs_2, fs_jpim1           ! vector opt.
-            zwuwtl(ji,jj, 1 ) = 0.e0
-            zwvwtl(ji,jj, 1 ) = 0.e0
-            zwuwtl(ji,jj,jpk) = 0.e0
-            zwvwtl(ji,jj,jpk) = 0.e0
+            zwuwtl(ji,jj, 1 ) = 0.0_wp
+            zwvwtl(ji,jj, 1 ) = 0.0_wp
+            zwuwtl(ji,jj,jpk) = 0.0_wp
+            zwvwtl(ji,jj,jpk) = 0.0_wp
          END DO
       END DO
@@ -210,4 +210,12 @@
          END DO
       END DO
+      DO jj = 2, jpjm1              ! Surface and bottom values set to zero
+         DO ji = fs_2, fs_jpim1           ! vector opt.
+            zwuwad(ji,jj, 1 ) = 0.0_wp
+            zwvwad(ji,jj, 1 ) = 0.0_wp
+            zwuwad(ji,jj,jpk) = 0.0_wp
+            zwvwad(ji,jj,jpk) = 0.0_wp
+         END DO
+      END DO
       DO jk = jpkm1, 2, -1             ! Vertical momentum advection at level w and u- and v- vertical
          DO jj = 2, jpj                   ! vertical fluxes 
Index: branches/TAM_V3_0/NEMOTAM/OPATAM_SRC/DYN/dynzdf_exp_tam.F90
===================================================================
--- branches/TAM_V3_0/NEMOTAM/OPATAM_SRC/DYN/dynzdf_exp_tam.F90	(revision 1947)
+++ branches/TAM_V3_0/NEMOTAM/OPATAM_SRC/DYN/dynzdf_exp_tam.F90	(revision 2587)
@@ -20,5 +20,46 @@
    !! * Modules used
 
-   USE in_out_manager  ! I/O manager
+   USE par_kind      , ONLY: & ! Precision variables
+      & wp
+   USE par_oce       , ONLY: & ! Ocean space and time domain variables
+      & jpi,                 &
+      & jpj,                 & 
+      & jpk,                 & 
+      & jpim1,               &
+      & jpjm1,               & 
+      & jpkm1
+   USE oce_tam       , ONLY: & ! ocean dynamics and tracers
+      & ub_tl,               &
+      & vb_tl,               &
+      & ua_tl,               &
+      & va_tl,               &
+      & ub_ad,               &
+      & vb_ad,               &
+      & ua_ad,               &
+      & va_ad
+   USE zdf_oce       , ONLY: & ! ocean vertical physics
+      & avmu,                &
+      & avmv,                &
+      & n_zdfexp
+   USE dom_oce       , ONLY: & ! ocean space and time domain
+#if defined key_zco
+      & e3t_0,               &
+      & e3w_0,               &
+#else
+      & e3u,                 &
+      & e3v,                 &
+      & e3uw,                &
+      & e3vw,                &
+#endif
+      & umask,               &
+      & vmask
+   USE phycst        , ONLY: & ! physical constants
+      & rau0
+   USE in_out_manager, ONLY: & ! I/O manager
+      & nit000,              &
+      & nitend,              &
+      & numout,              &
+      & lwp,                 &
+      & ctl_stop
    IMPLICIT NONE
    PRIVATE
@@ -59,6 +100,6 @@
       !! * Local declarations
       INTEGER ::   ji, jj, jk, jl                              ! dummy loop indices
-      REAL(wp) ::   zrau0r, zlavmr, zua, zva                   ! temporary scalars
-      REAL(wp), DIMENSION(jpi,jpk) ::   zwx, zwy, zwz, zww     ! temporary workspace arrays
+      REAL(wp) ::   zrau0r, zlavmr, zuatl, zvatl                   ! temporary scalars
+      REAL(wp), DIMENSION(jpi,jpk) ::   zwxtl, zwytl, zwztl, zwwtl     ! temporary workspace arrays
       !!----------------------------------------------------------------------
 
@@ -68,6 +109,58 @@
          IF(lwp) WRITE(numout,*) '~~~~~~~~~~~~~~ '
       ENDIF
-
-      CALL ctl_stop ('dyn_zdf_exp_tan not available yet')
+      ! Local constant initialization
+      ! -----------------------------
+      zrau0r = 1. / rau0                                   ! inverse of the reference density
+      zlavmr = 1. / float( n_zdfexp )                      ! inverse of the number of sub time step
+
+      !                                                ! ===============
+      DO jj = 2, jpjm1                                 !  Vertical slab
+         !                                             ! ===============
+
+         ! Surface boundary condition
+         DO ji = 2, jpim1
+            zwytl(ji,1) = 0.0_wp
+            zwwtl(ji,1) = 0.0_wp
+         END DO  
+
+         ! Initialization of x, z and contingently trends array
+         DO jk = 1, jpk
+            DO ji = 2, jpim1
+               zwxtl(ji,jk) = ub_tl(ji,jj,jk)
+               zwztl(ji,jk) = vb_tl(ji,jj,jk)
+            END DO  
+         END DO  
+
+         ! Time splitting loop
+         DO jl = 1, n_zdfexp
+
+            ! First vertical derivative
+            DO jk = 2, jpk
+               DO ji = 2, jpim1
+                  zwytl(ji,jk) = avmu(ji,jj,jk) * ( zwxtl(ji,jk-1) - zwxtl(ji,jk) ) / fse3uw(ji,jj,jk) 
+                  zwwtl(ji,jk) = avmv(ji,jj,jk) * ( zwztl(ji,jk-1) - zwztl(ji,jk) ) / fse3vw(ji,jj,jk)
+               END DO  
+            END DO  
+
+            ! Second vertical derivative and trend estimation at kt+l*rdt/n_zdfexp
+            DO jk = 1, jpkm1
+               DO ji = 2, jpim1
+                  zuatl = zlavmr*( zwytl(ji,jk) - zwytl(ji,jk+1) ) / fse3u(ji,jj,jk)
+                  zvatl = zlavmr*( zwwtl(ji,jk) - zwwtl(ji,jk+1) ) / fse3v(ji,jj,jk)
+                  ua_tl(ji,jj,jk) = ua_tl(ji,jj,jk) + zuatl
+                  va_tl(ji,jj,jk) = va_tl(ji,jj,jk) + zvatl
+
+                  zwxtl(ji,jk) = zwxtl(ji,jk) + p2dt*zuatl*umask(ji,jj,jk)
+                  zwztl(ji,jk) = zwztl(ji,jk) + p2dt*zvatl*vmask(ji,jj,jk)
+               END DO  
+            END DO  
+
+         END DO  
+
+         !                                             ! ===============
+      END DO                                           !   End of slab
+      !                                                ! ===============
+
+
    END SUBROUTINE dyn_zdf_exp_tan
    SUBROUTINE dyn_zdf_exp_adj( kt, p2dt )
Index: branches/TAM_V3_0/NEMOTAM/OPATAM_SRC/DYN/dynzdf_imp_tam.F90
===================================================================
--- branches/TAM_V3_0/NEMOTAM/OPATAM_SRC/DYN/dynzdf_imp_tam.F90	(revision 1947)
+++ branches/TAM_V3_0/NEMOTAM/OPATAM_SRC/DYN/dynzdf_imp_tam.F90	(revision 2587)
@@ -126,5 +126,5 @@
             DO ji = fs_2, fs_jpim1   ! vector opt.
                zcoef = - p2dt / fse3u(ji,jj,jk)
-               zwi(ji,jj,jk) = zcoef * avmu(ji,jj,jk  ) / fse3uw(ji,jj,jk  )
+               zwi(ji,jj,jk) = zcoef * avmu(ji,jj,jk  ) / fse3uw(ji,jj,jk  ) * umask(ji,jj,jk)
                zzws          = zcoef * avmu(ji,jj,jk+1) / fse3uw(ji,jj,jk+1)
                zws(ji,jj,jk) = zzws  * umask(ji,jj,jk+1)
Index: branches/TAM_V3_0/NEMOTAM/OPATAM_SRC/SBC/sbc_oce_tam.F90
===================================================================
--- branches/TAM_V3_0/NEMOTAM/OPATAM_SRC/SBC/sbc_oce_tam.F90	(revision 1947)
+++ branches/TAM_V3_0/NEMOTAM/OPATAM_SRC/SBC/sbc_oce_tam.F90	(revision 2587)
@@ -28,4 +28,5 @@
    PUBLIC &
       & sbc_oce_tam_init, & !: Initialize the TAM fields
+      & sbc_oce_tam_deallocate, & !: Deallocate the TAM fields
    !!----------------------------------------------------------------------
    !!              Ocean Surface Boundary Condition fields
@@ -295,4 +296,71 @@
 
    END SUBROUTINE sbc_oce_tam_init
+   SUBROUTINE sbc_oce_tam_deallocate( kindic )
+      !!-----------------------------------------------------------------------
+      !!
+      !!                  ***  ROUTINE sbc_oce_tam_init  ***
+      !!
+      !! ** Purpose : Allocate and initialize the tangent linear and 
+      !!              adjoint arrays
+      !!
+      !! ** Method  : kindic = 0  deallocate both tl and ad variables
+      !!              kindic = 1  deallocate only tl variables
+      !!              kindic = 2  deallocate only ad variables
+      !!
+      !! ** Action  :
+      !!                   
+      !! References : 
+      !!
+      !! History :
+      !!        ! 2010-06 (A. Vidard) Initial version 
+      !!-----------------------------------------------------------------------
+      !! * Arguments
+      INTEGER, INTENT(IN) :: &
+         & kindic        ! indicate which variables to deallocate
+
+      !! * Local declarations
+      
+      ! Deallocate tangent linear variable arrays
+      ! ---------------------------------------
+      
+      IF ( kindic == 0 .OR. kindic == 1 ) THEN
+
+         IF ( ALLOCATED(utau_tl) )    DEALLOCATE( utau_tl )
+         IF ( ALLOCATED(vtau_tl) )    DEALLOCATE( vtau_tl )
+         IF ( ALLOCATED(wndm_tl) )    DEALLOCATE( wndm_tl )
+         IF ( ALLOCATED(qns_tl) )     DEALLOCATE( qns_tl )
+         IF ( ALLOCATED(qsr_tl) )     DEALLOCATE( qsr_tl )
+         IF ( ALLOCATED(emp_tl) )     DEALLOCATE( emp_tl )
+         IF ( ALLOCATED(emps_tl) )    DEALLOCATE( emps_tl )
+         IF ( ALLOCATED(fr_i_tl) )    DEALLOCATE( fr_i_tl )
+         IF ( ALLOCATED(ssu_m_tl) )   DEALLOCATE( ssu_m_tl )
+         IF ( ALLOCATED(ssv_m_tl) )   DEALLOCATE( ssv_m_tl )
+         IF ( ALLOCATED(sst_m_tl) )   DEALLOCATE( sst_m_tl )
+         IF ( ALLOCATED(sss_m_tl) )   DEALLOCATE( sss_m_tl )
+
+
+      ENDIF
+
+      IF ( kindic == 0 .OR. kindic == 2 ) THEN
+
+         ! Deallocate adjoint variable arrays
+         ! --------------------------------
+      
+         IF ( ALLOCATED(utau_ad) )    DEALLOCATE( utau_ad )
+         IF ( ALLOCATED(vtau_ad) )    DEALLOCATE( vtau_ad )
+         IF ( ALLOCATED(wndm_ad) )    DEALLOCATE( wndm_ad )
+         IF ( ALLOCATED(qns_ad) )     DEALLOCATE( qns_ad )
+         IF ( ALLOCATED(qsr_ad) )     DEALLOCATE( qsr_ad )
+         IF ( ALLOCATED(emp_ad) )     DEALLOCATE( emp_ad )
+         IF ( ALLOCATED(emps_ad) )    DEALLOCATE( emps_ad )
+         IF ( ALLOCATED(fr_i_ad) )    DEALLOCATE( fr_i_ad )
+         IF ( ALLOCATED(ssu_m_ad) )   DEALLOCATE( ssu_m_ad )
+         IF ( ALLOCATED(ssv_m_ad) )   DEALLOCATE( ssv_m_ad )
+         IF ( ALLOCATED(sst_m_ad) )   DEALLOCATE( sst_m_ad )
+         IF ( ALLOCATED(sss_m_ad) )   DEALLOCATE( sss_m_ad )
+         
+      ENDIF
+
+   END SUBROUTINE sbc_oce_tam_deallocate
 #endif
 
Index: branches/TAM_V3_0/NEMOTAM/OPATAM_SRC/SOL/sol_oce_tam.F90
===================================================================
--- branches/TAM_V3_0/NEMOTAM/OPATAM_SRC/SOL/sol_oce_tam.F90	(revision 1947)
+++ branches/TAM_V3_0/NEMOTAM/OPATAM_SRC/SOL/sol_oce_tam.F90	(revision 2587)
@@ -31,7 +31,10 @@
       & nmax_fs
 !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
+   USE sol_oce       , ONLY: &
+      & nmin
+#if defined key_dynspg_flt
    USE solver        , ONLY: & ! Solver
       & solver_init
-
+#endif
    !! * Routine accessibility
    
@@ -41,4 +44,5 @@
    PUBLIC &
       & sol_oce_tam_init, & !: routine called by nemovar.F90
+      & sol_oce_tam_deallocate, &
                     !
       & gcx_tl,   & !: Tangent of now solution of the elliptic equation
@@ -48,6 +52,6 @@
       & gcx_ad,   & !: Adjoint of solution of the elliptic equation
       & gcxb_ad,  & !: Adjoint of before solution of the elliptic equation
-      & gcb_ad      !: Adjoint of 2nd member of barotropic linear system
-
+      & gcb_ad ,  & !: Adjoint of 2nd member of barotropic linear system
+      & nitsor
    !! * Module variables
    INTEGER, DIMENSION(:), ALLOCATABLE :: &
@@ -89,15 +93,16 @@
          & kindic        ! indicate which variables to allocate/initialize
 
+#if defined key_dynspg_flt
       IF ( kindic == 0 .OR. kindic == 1 ) THEN
 
+         IF ( kindic == 0 ) CALL solver_init( nit000 )
+
          IF ( .NOT. ALLOCATED(nitsor) ) THEN
 
             ALLOCATE( nitsor( nitend - nit000 + 1 ) )
-
-         ENDIF
-
-         nitsor(:) = nmax_fs
-
-      IF ( kindic == 0 ) CALL solver_init( nit000 )
+            nitsor(:) = nmin
+
+         ENDIF
+
 
       ENDIF
@@ -162,6 +167,55 @@
 
       ENDIF
-
+#endif
    END SUBROUTINE sol_oce_tam_init
-
+   SUBROUTINE sol_oce_tam_deallocate(kindic)
+      !!-----------------------------------------------------------------------
+      !!
+      !!                  ***  ROUTINE sol_oce_tam_deallocate  ***
+      !!
+      !! ** Purpose : 
+      !!
+      !! ** Method  : kindic = 0  deallocate both tl and ad variables
+      !!              kindic = 1  deallocate only tl variables
+      !!              kindic = 2  deallocate only ad variables
+      !!
+      !! ** Action  :
+      !!                   
+      !! References : 
+      !!
+      !! History :
+      !!         ! 2010-06 (A. Vidard) Initial version
+      !!-----------------------------------------------------------------------
+      !! * Arguments
+      INTEGER, INTENT(IN) :: &
+         & kindic        ! indicate which variables to allocate/initialize
+#if defined key_dynspg_flt
+      IF ( kindic == 0 ) THEN
+         IF ( ALLOCATED(nitsor) )  DEALLOCATE( nitsor )
+      END IF
+
+      IF ( kindic == 0 .OR. kindic == 1 ) THEN
+
+         IF ( ALLOCATED(gcx_tl) )  DEALLOCATE( gcx_tl  )
+
+         IF ( ALLOCATED(gcxb_tl) ) DEALLOCATE( gcxb_tl )
+
+         IF ( ALLOCATED(gcb_tl) )  DEALLOCATE( gcb_tl  )
+
+         IF ( ALLOCATED(gcr_tl) )  DEALLOCATE( gcr_tl  )
+
+      ENDIF
+
+      IF ( kindic == 0 .OR. kindic == 2 ) THEN
+
+         IF ( ALLOCATED(gcx_ad) )  DEALLOCATE( gcx_ad  )
+
+         IF ( ALLOCATED(gcxb_ad) ) DEALLOCATE( gcxb_ad )
+
+         IF ( ALLOCATED(gcb_ad) )  DEALLOCATE( gcb_ad  )
+
+      ENDIF
+      
+#endif
+   END SUBROUTINE sol_oce_tam_deallocate
 END MODULE sol_oce_tam
